function A = Hermite(alappontok, ertekek)
%Hermite interpolci; ha egy alappont tbbszr szerepel, akkor az
%ertekek vektorban a megfelel indexeken f(x_i), f'(x_i),... szerepel.

n = length(alappontok);

A = zeros(n,n+1);

A(:,1) = alappontok;
A(:,2) = ertekek;

for i=2:n,
    if A(i,1)==A(i-1,1),    %ha azonosak az alappontok, akkor mell 
        A(i,2) = A(i-1,2);  %a megfelel fv rtkek.
    end;
end;

for i=3:(n+1),  %cellk feltltse
    for j=(i-1):n,
        if A(j,1) == A(j-i+2,1),    %ha a nevezben azonos pontok szere-
                                    %pelnnek
            k = j-i+2;
            xi = A(j-i+2,1);
            %megkeressk az alappont "els" indext
            while k>0 && A(k,1) == xi, k = k-1; end;
            A(j,i) = ertekek(k+i-1) / factorial(i-2); %rtkl adjuk neki a derivltat.
        else
            A(j,i) = (A(j,i-1)-A(j-1,i-1)) / (A(j,1)-A(j-i+2,1));
        end;
    end;
end;

x = [min(alappontok):0.001:max(alappontok)];
omega_n = ones(size(x));
y = zeros(size(x));

for i=1:n,
    y = y + (A(i,i+1) * omega_n);
    omega_n = omega_n .* (x-alappontok(i));
end;

plot(x,y,A(:,1),A(:,2),'ro');